/*  igorplug.h --- interface to libigor

 Copyright (C) 2009 by Walter C. Pelissero

 Author: Walter C. Pelissero <walter@pelissero.de>
 Project: igorplug

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public License
as published by the Free Software Foundation; either version 2.1
of the License, or (at your option) any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA*/

#ifndef _igorplug_h_INCLUDED
#define _igorplug_h_INCLUDED

/* Length of the data portion of a packet. */
#define IGORPLUG_DATA_LENGTH(buf)	(buf[0])
/* Serial number of the packet.  This gets increased at every
   packet. */
#define IGORPLUG_SERIAL(buf)		(buf[1])
/* Offset of data within the original bit stream.  This is non-zero
   only when the transmitted sequence is longer than the IgorPlug
   buffer (which appears to be limited to 36 bytes).  In practice this
   signals a buffer overflow, thus the packet is not complete. */
#define IGORPLUG_OFFSET(buf)		(buf[2])
#define IGORPLUG_DATA(buf)		(buf+3)


typedef unsigned char IRbyte;
typedef IRbyte *IRbuffer;

extern int igorplug_open_device (const char *device_pathname);
extern IRbuffer igorplug_alloc_buffer ();
extern int igorplug_read_buffer (int fd, IRbuffer buf);
extern int igorplug_read_buffer2 (int fd, IRbuffer buf, unsigned tolerance);

#endif	/* _igorplug_h_INCLUDED */
